const fs = require('fs').promises;
const path = require('path');
const process = require('process');
const { authenticate } = require('@google-cloud/local-auth');
const { google } = require('googleapis');
const express = require('express')
const app = express()
const port = 84
var spreadsheetId = "1GaCF2NejkzxKD0Eu9f-SDN1IQCShMCoLQs2w9i2huSs";
const SCOPES = ['https://www.googleapis.com/auth/spreadsheets.readonly'];
const TOKEN_PATH = path.join(process.cwd(), 'token.json');
const CREDENTIALS_PATH = path.join(process.cwd(), 'credentials.json');
var auth = null;
/**
 * Reads previously authorized credentials from the save file.
 * @return {Promise<OAuth2Client|null>}
 */
async function loadSavedCredentialsIfExist() {
    try {
        const content = await fs.readFile(TOKEN_PATH);
        const credentials = JSON.parse(content);
        return google.auth.fromJSON(credentials);
    } catch (err) {
        return null;
    }
}
/**
 * Serializes credentials to a file comptible with GoogleAUth.fromJSON.
 * @param {OAuth2Client} client
 * @return {Promise<void>}
 */
async function saveCredentials(client) {
    const content = await fs.readFile(CREDENTIALS_PATH);
    const keys = JSON.parse(content);
    const key = keys.installed || keys.web;
    const payload = JSON.stringify({
        type: 'authorized_user',
        client_id: key.client_id,
        client_secret: key.client_secret,
        refresh_token: client.credentials.refresh_token,
    });
    await fs.writeFile(TOKEN_PATH, payload);
}
/**
 * Load or request or authorization to call APIs.
 */
async function authorize() {
    let client = await loadSavedCredentialsIfExist();
    if (client) {
        return client;
    }
    client = await authenticate({
        scopes: SCOPES,
        keyfilePath: CREDENTIALS_PATH,
    });
    if (client.credentials) {
        await saveCredentials(client);
    }
    return client;
}
async function getdata(auth, sheettap, range) { 
    // const sheets = google.sheets({ version: 'v4', auth });
    const sheets = google.sheets('v4');
    const res = await sheets.spreadsheets.values.get({
        auth: "AIzaSyC9jxRiM0sRCViiHik04SwodeR123L7cYM",
        spreadsheetId: spreadsheetId,
        range: sheettap + '!' + range,
    });
    return res.data.values;
}

/* Route All API START */

// params [key] = id ผล
app.get('/find', async (req, res) => {
    var resp = "";
    if (req.query.key !== null  && req.query.key !== "" && req.query.key !== undefined) {
        resp = await getdata(this.auth, 'Sheet1', 'A2:H115'); // ดึงมาทั้งก้อน
        var start_key = 2; // แถวเริ่มต้น
        resp.forEach(async key =>  {
            if (key[1] == req.query.key) { // check string == string
                resp = {
                    "key": key[0],
                    "code": key[1],
                    "time": key[2],
                    "name": key[3],
                    "theme1": key[5],
                    "theme2": key[7]
                };
            }
            start_key++;
        });
    }
    res.json(resp)
})


// all load code start application to json format
app.get('/code', async (req, res) => {
    var resp = "";
    resp = await getdata(this.auth, 'Sheet1', 'A2:H115'); // ดึงมาทั้งก้อน
    let arr = []; // สร้าง Array ว่างไว้ก่อน
    resp.forEach(async key => {arr.push(key[1]);});
    // สร้างตัวแปร outputArr เพื่อเก็บ object แต่ละตัวในรูปแบบ [{"code":"ดจ"},{"code":"นอช"},{"code":"นอบ"}]
    let outputArr = [];
    // loop เพื่อสร้าง object แต่ละตัว
    for (let i = 0; i < arr.length; i++) {
        const obj = {};
        obj["code"] = arr[i];
        outputArr.push(obj);
    }
    res.json(outputArr)
})


// all load code start application to json format
app.get('/all', async (req, res) => {
    var resp = "";
    resp = await getdata(this.auth, 'Sheet1', 'A2:H115'); // ดึงมาทั้งก้อน
    let arr = []; // สร้าง Array ว่างไว้ก่อน theme1
    let arr2 = []; // สร้าง Array ว่างไว้ก่อน theme2
    let arrid = []; // สร้าง Array ว่างไว้ก่อน
    resp.forEach(async key => { 
        arr.push(key[5]);
        arr2.push(key[7]);
        arrid.push(key[1]); 
    });
    // สร้างตัวแปร outputArr เพื่อเก็บ object แต่ละตัวในรูปแบบ [{"code":"ดจ"},{"code":"นอช"},{"code":"นอบ"}]
    let outputArr = [];
    // loop เพื่อสร้าง object แต่ละตัว
    for (let i = 0; i < arr.length; i++) {
        const obj = {};
        obj["id"] = arrid[i];
        obj["theme1"] = arr[i];
        obj["theme2"] = arr2[i];
        outputArr.push(obj);
    }
    res.json(outputArr)
})


// all load code start application to json format
app.get('/menu', async (req, res) => {
    var resp = "";
    resp = await getdata(this.auth, 'Menu', 'A1:A1'); // ดึงมาทั้งก้อน
    res.json({"menu" : resp[0][0]})
})


// AUto Timer // SN 18-05-2566 AP
app.get('/auto', async (req, res) => {
    var resp = "";
    resp = await getdata(this.auth, 'Auto', 'A2:J115'); // ดึงมาทั้งก้อน
    let arr = []; // สร้าง Array ว่างไว้ก่อน theme1
    resp.forEach(async key => {
        var tmp = {
            "ID": key[0],                  // "28",
            "CODE": key[1],                // "ลทขว",
            "TIME": key[2],                // "20:00",
            "NAME": key[3],                // "ลาวท่าแขกVIP
            "AUTO": {          
                "TIME1": key[4],           // "10",
                "TIME2": key[5],           // "15",
                "TIME3": key[6],           // "20",
                "TIME4": key[7],           // "30",
                "TIME5": key[8]            // "40"
            },
            "ICON": key[9],                // "ลาวท่าแขกVIP
        }
        arr.push(tmp);
    });
    res.json(arr)
})
// EN 18-05-2566 AP

/* Route All API END */
app.listen(port, async () => {
     this.auth = await authorize();
    console.log(`Example app listening on port ${port}`)
})